
private ArrayList<GeoObject> geoObjects = new ArrayList<GeoObject>();
private ArrayList<Point> selectedPoints= new ArrayList<Point>();

private Point dPoint = null;
private int r=0, g=0, b=0;

///////////////////////////////////////////////////////////////////

void setup() {
  size(800,800);
}

///////////////////////////////////////////////////////////////////

void draw() {
  background(255);
  for (GeoObject obj : geoObjects ) obj.display();
}

///////////////////////////////////////////////////////////////////
//Wird in der Nähe eines vorhandenen Punktes geklickt,...

void mousePressed() {  
  dPoint = null;
  for (GeoObject obj : geoObjects ) {
    if (obj instanceof Point) {
      Point p = (Point) obj;
      double d = p.abstandZu(mouseX, mouseY);
      if (d < 5) dPoint = p;
    }
  }
  if (dPoint == null) {
    Point newPoint = new Point(mouseX, mouseY);
    geoObjects.add(newPoint);
  } else {
    if (mouseButton == RIGHT) {
      if (dPoint.getSelected()) {
        dPoint.setSelected(false);
        selectedPoints.remove(dPoint);
      } else {
        dPoint.setSelected(true);
        selectedPoints.add(dPoint);
      }
    }
  }
}

///////////////////////////////////////////////////////////////////

public void mouseDragged() {
  if (dPoint != null) {
    dPoint.setX(mouseX);
    dPoint.setY(mouseY);
  }
}

///////////////////////////////////////////////////////////////////

void keyPressed() {
  if (key == 'l') {
    if (selectedPoints.size() == 2) {
      Line line = new Line(selectedPoints.get(0), selectedPoints.get(1));
      line.setfarbe(color(r, g, b));
      geoObjects.add(line);
    } 
    selectedPointsLoeschen();
  } 

  if (key == 'p') {
    if (selectedPoints.size() >= 3) {    
      Polygon poly = new Polygon(selectedPoints);
      geoObjects.add(poly);
    } 
    selectedPointsLoeschen();
  }
  
}

///////////////////////////////////////////////////////////////////

void selectedPointsLoeschen() {
  for (Point p : selectedPoints) {
    p.setSelected(false);
  } 
  selectedPoints.clear();
}